From 2121c13bb27a58b663309038c0e182a6e5c0cf7c Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 4 Apr 2019 11:28:55 +0200
Subject: [PATCH 4/4] matomo: french translation (#31778)

---
 hobo/locale/fr/LC_MESSAGES/django.po | 160 +++++++++++++++++++++++++--
 1 file changed, 149 insertions(+), 11 deletions(-)

diff --git a/hobo/locale/fr/LC_MESSAGES/django.po b/hobo/locale/fr/LC_MESSAGES/django.po
index 0235ea2..d7dc42e 100644
--- a/hobo/locale/fr/LC_MESSAGES/django.po
+++ b/hobo/locale/fr/LC_MESSAGES/django.po
@@ -7,8 +7,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: hobo 0\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2019-01-18 09:37+0000\n"
-"PO-Revision-Date: 2019-01-18 10:32+0100\n"
+"POT-Creation-Date: 2019-04-04 08:47+0000\n"
+"PO-Revision-Date: 2019-04-05 09:08+0200\n"
 "Last-Translator: Frederic Peters <fpeters@entrouvert.com>\n"
 "Language: French\n"
 "MIME-Version: 1.0\n"
@@ -79,11 +79,16 @@ msgstr ""
 
 #: franceconnect/templates/hobo/franceconnect_disable.html:15
 #: franceconnect/templates/hobo/franceconnect_home.html:13
+#: matomo/templates/hobo/matomo_disable.html:15
+#: matomo/templates/hobo/matomo_home.html:14
 msgid "Disable"
 msgstr "Désactiver"
 
 #: franceconnect/templates/hobo/franceconnect_disable.html:16
 #: franceconnect/templates/hobo/franceconnect_enable.html:16
+#: matomo/templates/hobo/matomo_disable.html:16
+#: matomo/templates/hobo/matomo_enable_auto.html:16
+#: matomo/templates/hobo/matomo_enable_manual.html:16
 #: profile/templates/profile/attributedefinition_form.html:14
 #: theme/templates/hobo/theme_options.html:20
 msgid "Cancel"
@@ -96,6 +101,8 @@ msgstr ""
 
 #: franceconnect/templates/hobo/franceconnect_enable.html:15
 #: franceconnect/templates/hobo/franceconnect_home.html:32
+#: matomo/templates/hobo/matomo_enable_auto.html:15
+#: matomo/templates/hobo/matomo_enable_manual.html:15
 msgid "Enable"
 msgstr "Activer"
 
@@ -116,15 +123,146 @@ msgstr ""
 " "
 
 #: franceconnect/templates/hobo/franceconnect_home.html:29
+#: matomo/templates/hobo/matomo_home.html:73
 msgid "Support is currently disabled."
 msgstr "La prise en charge est actuellement désactivée."
 
 #: franceconnect/templates/hobo/franceconnect_home.html:41
+#: matomo/templates/hobo/matomo_home.html:105
 #: profile/templates/profile/attributedefinition_form.html:13
 #: templates/hobo/manager_home.html:23
 msgid "Save"
 msgstr "Enregistrer"
 
+#: matomo/forms.py:30
+msgid "Tracking Javascript"
+msgstr "Code de suivi Javascript"
+
+#: matomo/forms.py:31
+msgid ""
+"See <a href=\"https://developer.matomo.org/guides/tracking-javascript-guide"
+"\">Matomo partners site</a> for getting your Javascript's tracking code."
+msgstr ""
+"Voir <a href=\"https://developer.matomo.org/guides/tracking-javascript-guide"
+"\">sur le site de Matomo</a> comment récupérer votre code de suivi Javascript."
+
+#: matomo/templates/hobo/matomo_disable.html:5
+#: matomo/templates/hobo/matomo_enable_auto.html:5
+#: matomo/templates/hobo/matomo_enable_manual.html:5
+#: matomo/templates/hobo/matomo_home.html:10 templates/hobo/home.html:13
+msgid "User tracking"
+msgstr "Mesure d'audience"
+
+#: matomo/templates/hobo/matomo_disable.html:12
+msgid "Are you sure you want to disable user tracking support?"
+msgstr ""
+"Êtes-vous sûr·e de vouloir désactiver la prise en charge de la mesure "
+"d'audience ?"
+
+#: matomo/templates/hobo/matomo_enable_auto.html:12
+msgid "Are you sure you want to enable automatic user tracking support?"
+msgstr ""
+"Êtes-vous sûr·e de vouloir activer la prise en charge automatique de la "
+"mesure d'audience ?"
+
+#: matomo/templates/hobo/matomo_enable_manual.html:12
+msgid "Are you sure you want to enable manual user tracking support?"
+msgstr ""
+"Êtes-vous sûr·e de vouloir activer la prise en charge manuelle de la mesure "
+"d'audience ?"
+
+#: matomo/templates/hobo/matomo_home.html:18
+msgid "Open visit tracking dashboard"
+msgstr "Ouvrir le tableau de bord de la mesure d'audience"
+
+#: matomo/templates/hobo/matomo_home.html:30
+msgid ""
+"\n"
+"    The audience measurement tools are deployed to obtain information about\n"
+"    visitor navigation. They help to understand where users come from on a "
+"site\n"
+"    and reconstruct their browsing activity. These tools use technologies "
+"that\n"
+"    permit to trace users on your site and associate a \"referrer\" or "
+"campaign\n"
+"    with a unique identifier.\n"
+"    "
+msgstr ""
+"\n"
+"Les outils de mesures d’audience sont déployés afin d’obtenir des "
+"informations sur la navigation des visiteurs. Ils permettent notamment "
+"de comprendre comment les utilisateurs arrivent sur un site et de reconstituer "
+"leur parcours. Ces outils utilisent des technologies permettant de tracer "
+"les utilisateurs sur le site et d’associer un « referrer » ou une campagne "
+"à un identifiant unique."
+
+#: matomo/templates/hobo/matomo_home.html:40
+msgid ""
+"\n"
+"      Publik can automatically use a tool called \"Matomo\", which is the "
+"tracker\n"
+"      solution recommended by the National Commission for Data Protection "
+"and Liberties (<a\n"
+"      href=\"https://www.cnil.fr/fr/solutions-pour-les-cookies-de-mesure-"
+"daudience\">CNIL-France</a>).\n"
+"      "
+msgstr ""
+"\nPublik peut utiliser automatiquement l'outil de mesures d’audience "
+"\"Matomo\" recommandé par la solution d’analytics recommandée par la "
+"Commission Nationale de l'Informatique et des Libertés "
+"(<a href=\"https://www.cnil.fr/fr/solutions-pour-les-cookies-de-mesure-"
+"daudience\">CNIL-France</a>)."
+
+#: matomo/templates/hobo/matomo_home.html:48
+msgid ""
+"\n"
+"      Matomo is the tracker solution recommended by the National Commission "
+"for Data\n"
+"      Protection and Liberties (<a\n"
+"      href=\"https://www.cnil.fr/fr/solutions-pour-les-cookies-de-mesure-"
+"daudience\">CNIL-France</a>).\n"
+"      It requires <a href=\"https://www.cnil.fr/sites/default/files/typo/"
+"document/Configuration_piwik.pdf\"\n"
+"      >little configuration</a> to be exempt from legal consent.\n"
+"      "
+msgstr ""
+"\nMatomo est la solution d’analytics recommandé par la "
+"Commission Nationale de l'Informatique et des Libertés "
+"(<a href=\"https://www.cnil.fr/fr/solutions-pour-les-cookies-de-mesure-"
+"daudience\">CNIL-France</a>).\n"
+"L'outil Matomo requiert qu'un léger <a href=\"https://"
+"www.cnil.fr/sites/default/files/typo/document/Configuration_piwik.pdf\">"
+"paramétrage</a> pour être exempté de consentement en conformité avec la "
+"règlementation."
+
+#: matomo/templates/hobo/matomo_home.html:59
+msgid "Manual configuration."
+msgstr "Configuration manuelle"
+
+#: matomo/templates/hobo/matomo_home.html:61
+msgid "Automatic configuration."
+msgstr "Configuration automatique"
+
+#: matomo/templates/hobo/matomo_home.html:76
+msgid "Manual Configuration"
+msgstr "Configuration manuelle"
+
+#: matomo/templates/hobo/matomo_home.html:78
+msgid "Automatic Configuration"
+msgstr "Configuration automatique"
+
+#: matomo/templates/hobo/matomo_home.html:86
+msgid "Excellent respect of user rights."
+msgstr "Excellent respect des droits des usagers."
+
+#: matomo/templates/hobo/matomo_home.html:90
+msgid "Good respect of user rights."
+msgstr "Bon respect des droits des usagers."
+
+#: matomo/templates/hobo/matomo_home.html:94
+msgid "No respect of user rights."
+msgstr "Non respect des droits des usagers."
+
 #: profile/models.py:22
 msgid "label"
 msgstr "libellé"
@@ -215,11 +353,11 @@ msgstr ""
 msgid "options"
 msgstr "options"
 
-#: settings.py:154
+#: settings.py:155
 msgid "User Portal"
 msgstr "Portail usager"
 
-#: settings.py:155
+#: settings.py:156
 msgid "Agent Portal"
 msgstr "Portail agent"
 
@@ -239,31 +377,31 @@ msgstr "Système"
 msgid "Theme"
 msgstr "Intégration graphique"
 
-#: templates/hobo/home.html:13
+#: templates/hobo/home.html:14
 msgid "Services"
 msgstr "Services"
 
-#: templates/hobo/home.html:14
+#: templates/hobo/home.html:15
 msgid "Variables"
 msgstr "Variables"
 
-#: templates/hobo/home.html:28
+#: templates/hobo/home.html:29
 msgid "checking..."
 msgstr "vérification en cours…"
 
-#: templates/hobo/home.html:29
+#: templates/hobo/home.html:30
 msgid "DNS"
 msgstr "DNS"
 
-#: templates/hobo/home.html:30
+#: templates/hobo/home.html:31
 msgid "Certificate"
 msgstr "Certificat"
 
-#: templates/hobo/home.html:31
+#: templates/hobo/home.html:32
 msgid "Web"
 msgstr "Web"
 
-#: templates/hobo/home.html:38
+#: templates/hobo/home.html:39
 msgid ""
 "\n"
 "  This deployment doesn't have any service deployed yet. Click on the\n"
-- 
2.20.1